﻿if select(6, GetAddOnInfo("PitBull_" .. (debugstack():match("[i%.][t%.][B%.]ull\\Modules\\(.-)\\") or debugstack():match("[i%.][t%.][B%.]ull\\(.-)\\") or ""))) ~= "MISSING" then return end

local VERSION = tonumber(("$Revision: 63815 $"):match("%d+"))

local L = AceLibrary("AceLocale-2.2"):new("PitBull_Banzai")
L:RegisterTranslations("enUS", function() return {
	["Adds aggro coloring to PitBull."] = true,
	["Aggro color"] = true,
	["Sets which color to use on the health bar of units that have aggro."] = true,
	["Enable aggro indicator"] = true,
	["Change the color of this unit's health bar when it gets aggro."] = true,
} end)
L:RegisterTranslations("koKR", function() return {
	["Adds aggro coloring to PitBull."] = "PitBull에 어그로 색상화를 추가합니다.",
	["Aggro color"] = "어그로 색상",
	["Sets which color to use on the health bar of units that have aggro."] = "어그로를 갖고 있는 유닛의 생명력바에 사용할 색상을 설정합니다",
	["Enable aggro indicator"] = "어그로 아이콘 활성화",
	["Change the color of this unit's health bar when it gets aggro."] = "어그로를 획득한 경우 이 유닛의 생명력바의 색상을 변경합니다.",
} end)
L:RegisterTranslations("zhCN",function() return{
	["Adds aggro coloring to PitBull."] = "PitBull 战斗指示器颜色设置.",
	["Aggro color"] = "指示器颜色",
	["Sets which color to use on the health bar of units that have aggro."] = "设置战斗开始时该框架生命条颜色.",
	["Enable aggro indicator"] = "开启战斗指示器",
	["Change the color of this unit's health bar when it gets aggro."] = "设置战斗开始时改变该框架生命颜色.",
}end)
L:RegisterTranslations("frFR",function() return{
	["Adds aggro coloring to PitBull."] = "Ajoute la coloration par aggro.",
	["Aggro color"] = "Couleur de l'aggro",
	["Sets which color to use on the health bar of units that have aggro."] = "Définit quelle couleur doit être utilisée pour la barre de vie des unités qui ont l'aggro.",
	["Enable aggro indicator"] = "Activer l'indicateur d'aggro",
	["Change the color of this unit's health bar when it gets aggro."] = "Changer la couleur de la barre de vie des unités quand elles prennent l'aggro.",
}end)
L:RegisterTranslations("zhTW",function() return{
	["Adds aggro coloring to PitBull."] = "為PitBull增加戰鬥時的顏色.",
	["Aggro color"] = "戰鬥顏色",
	["Sets which color to use on the health bar of units that have aggro."] = "設定戰鬥時此單位的生命條顏色.",
	["Enable aggro indicator"] = "啟用戰鬥指示器",
	["Change the color of this unit's health bar when it gets aggro."] = "進入戰鬥,則改變此單位生命條的顏色.",
}end)

PitBull_Banzai = PitBull:NewModule("Banzai", "LibRockEvent-1.0", "LibRockHook-1.0")
local PitBull_Banzai = PitBull_Banzai
local self = PitBull_Banzai
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2008-03-07 10:32:42 -0500 (Fri, 07 Mar 2008) $"):match("%d%d%d%d%-%d%d%-%d%d")
end
self.desc = L["Adds aggro coloring to PitBull."]

local PitBull_HealthBar = PitBull:GetModule("HealthBar")

local banzai

function PitBull_Banzai:OnInitialize()
	self.db = PitBull:GetDatabaseNamespace("Banzai")
	PitBull:SetDatabaseNamespaceDefaults("Banzai", "profile", {
		color = {1.0, 0, 0, 1.0},
		groups = {
			target = {
				ignore = true,
			},
			targettarget = {
				ignore = true,
			},
			targettargettarget = {
				ignore = true,
			},
			["*"] = {},
		}
	})
end

local function callback(aggro, name, ...)
	for frame in PitBull:IterateUnitFramesForUnitName(name) do
		if frame and not self.db.profile.groups[frame.group].ignore then
			self:UpdateHealthbarColor(PitBull_HealthBar, name, frame)
		end
	end
end

function PitBull_Banzai:OnEnable()
	banzai = Rock("LibBanzai-2.0", false, true)
	if not banzai then
		error("PitBull_Banzai requires the library LibBanzai-2.0 to be available.")
	end
	
	banzai:RegisterCallback(callback)
	self:AddHook(PitBull_HealthBar, "UpdateHealthbarColor")
end

function PitBull_Banzai:OnDisable()
	banzai:UnregisterCallback(callback)
end

function PitBull_Banzai:UpdateHealthbarColor(module, unit, frame)
	if not frame.healthBar then
		return self.hooks[module].UpdateHealthbarColor(module, unit, frame)
	end
	if not self.db.profile.groups[frame.group].ignore then
		local aggro = banzai:GetUnitAggroByUnitName(unit)
		if aggro then
			local color = self.db.profile.color
			frame.healthBar:SetColor(unpack(color))
			frame.healthBar:SetBackgroundColor(nil)
			return
		end
	end
	self.hooks[module].UpdateHealthbarColor(module, unit, frame)
end
-- Global Options
PitBull:RegisterGlobalSetting("colors", "args", "banzai", function() return "@cache", {
	type = 'color',
	name = L["Aggro color"],
	desc = L["Sets which color to use on the health bar of units that have aggro."],
	get = function()
		return unpack(PitBull_Banzai.db.profile.color)
	end,
	set = function(r, g, b, a)
		PitBull_Banzai.db.profile.color = {r, g, b, a}
		for unit,frame in PitBull:IterateUnitFrames() do
			PitBull_Banzai:UpdateHealthbarColor(PitBull_HealthBar, unit, frame)
		end
	end,
} end)
-- Unit/Group Specific Options
local function getEnabled(group)
	return not PitBull_Banzai.db.profile.groups[group].ignore
end
local function setEnabled(group, value)
	PitBull_Banzai.db.profile.groups[group].ignore = not value
	for unit, frame in PitBull:IterateUnitFramesByGroup(group) do
		PitBull_Banzai:UpdateHealthbarColor(PitBull_HealthBar, unit, frame)
	end
end
PitBull_Banzai:RegisterPitBullOptionsMethod(function(group)
	return {
		type = 'boolean',
		name = L["Enable aggro indicator"],
		desc = L["Change the color of this unit's health bar when it gets aggro."],
		get = getEnabled,
		set = setEnabled,
		passValue = group,
	}
end)

